const inquirer = require('inquirer')
const files = require('./files')

module.exports = {
  // 获取 github 授权信息
  askGithubCredentials: () => {
    const questions = [
      {
        name: 'username',
        type: 'input',
        message: 'Enter your Github username or e-mail address:',
        validate: function (value) {
          if (value.length) {
            return true
          } else {
            return 'Please enter your username or e-mail address.'
          }
        }
      },
      {
        name: 'password',
        type: 'password',
        message: 'Enter your password:',
        validate: function (value) {
          if (value.length) {
            return true
          } else {
            return 'Please enter your password.'
          }
        }
      }
    ]
    return inquirer.prompt(questions)
  },
  // 获取 github 库的基本信息
  askRepoDetails: () => {
    const argv = require('minimist')(process.argv.slice(2))
    const questions = [
      {
        type: 'input',
        name: 'name',
        message: 'Enter a name for the repository: ',
        default: argv._[0] || files.getCurrentDirectoryBase(),
        validate: (value) => {
          if (value.length) {
            return true
          } else {
            return 'Please enter a name for the repository'
          }
        }
      },
      {
        type: 'input',
        name: 'visibility',
        message: 'Public or private: ',
        choices: ['public', 'private'],
        default: 'public'
      }
    ]
    return inquirer.prompt(questions)
  },
  // 获取需要 ignore 的文件
  askIgnoreFiles: (filelist) => {
    const questions = [
      {
        type: 'checkbox',
        name: 'ignore',
        message: 'Select the files and/or folders you wish to ignore: ',
        choices: filelist
      }
    ]
    return inquirer.prompt(questions)
  }
}